diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/sixlowpan/examples/example-ping-lr-wpan.cc ns-3.31/src/sixlowpan/examples/example-ping-lr-wpan.cc
--- ns-3.30.1/src/sixlowpan/examples/example-ping-lr-wpan.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/sixlowpan/examples/example-ping-lr-wpan.cc	2020-06-27 17:38:30.000000000 -0700
@@ -23,12 +23,9 @@
 #include "ns3/core-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/internet-apps-module.h"
-#include "ns3/ipv6-static-routing-helper.h"
 #include "ns3/mobility-module.h"
 #include "ns3/spectrum-module.h"
-#include "ns3/propagation-loss-model.h"
-#include "ns3/log.h"
-#include "ns3/ipv6-routing-table-entry.h"
+#include "ns3/propagation-module.h"
 #include "ns3/sixlowpan-module.h"
 #include "ns3/lr-wpan-module.h"
 
@@ -38,16 +35,26 @@
 
 int main (int argc, char** argv)
 {
-  CommandLine cmd;
+  bool verbose = false;
+  bool disablePcap = false;
+  bool disableAsciiTrace = false;
+  bool enableLSixlowLogLevelInfo = false;
+
+  CommandLine cmd (__FILE__);
+  cmd.AddValue ("verbose", "turn on log components", verbose);
+  cmd.AddValue ("disable-pcap", "disable PCAP generation", disablePcap);
+  cmd.AddValue ("disable-asciitrace", "disable ascii trace generation", disableAsciiTrace);
+  cmd.AddValue ("enable-sixlowpan-loginfo", "enable sixlowpan LOG_LEVEL_INFO (used for tests)", enableLSixlowLogLevelInfo);
   cmd.Parse (argc, argv);
   
-#if 0
-  LogComponentEnable ("Ping6Application", LOG_LEVEL_ALL);
-  LogComponentEnable ("LrWpanMac",LOG_LEVEL_ALL);
-  LogComponentEnable ("LrWpanPhy",LOG_LEVEL_ALL);
-  LogComponentEnable ("LrWpanNetDevice", LOG_LEVEL_ALL);
-  LogComponentEnable ("SixLowPanNetDevice", LOG_LEVEL_ALL);
-#endif
+  if (verbose)
+    {
+      LogComponentEnable ("Ping6Application", LOG_LEVEL_ALL);
+      LogComponentEnable ("LrWpanMac", LOG_LEVEL_ALL);
+      LogComponentEnable ("LrWpanPhy", LOG_LEVEL_ALL);
+      LogComponentEnable ("LrWpanNetDevice", LOG_LEVEL_ALL);
+      LogComponentEnable ("SixLowPanNetDevice", LOG_LEVEL_ALL);
+    }
 
   NodeContainer nodes;
   nodes.Create(2);
@@ -69,7 +76,9 @@
   NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(nodes);
 
   // Fake PAN association and short address assignment.
-  lrWpanHelper.AssociateToPan (lrwpanDevices, 0);
+  // This is needed because the lr-wpan module does not provide (yet)
+  // a full PAN association procedure.
+  lrWpanHelper.AssociateToPan (lrwpanDevices, 1);
 
   InternetStackHelper internetv6;
   internetv6.Install (nodes);
@@ -81,11 +90,14 @@
   ipv6.SetBase (Ipv6Address ("2001:2::"), Ipv6Prefix (64));
   Ipv6InterfaceContainer deviceInterfaces;
   deviceInterfaces = ipv6.Assign (devices);
-  // check if addresses are assigned
-  //std::cout<< deviceInterfaces.GetAddress(0,1)<<std::endl;
-  //std::cout<< deviceInterfaces.GetAddress(1,1)<<std::endl;
-
 
+  if (enableLSixlowLogLevelInfo)
+    {
+      std::cout << "Device 0: pseudo-Mac-48 " << Mac48Address::ConvertFrom (devices.Get (0)->GetAddress ())
+                << ", IPv6 Address " << deviceInterfaces.GetAddress (0,1) << std::endl;
+      std::cout << "Device 1: pseudo-Mac-48 " << Mac48Address::ConvertFrom (devices.Get (1)->GetAddress ())
+                << ", IPv6 Address " << deviceInterfaces.GetAddress (1,1) << std::endl;
+    }
    
   uint32_t packetSize = 10;
   uint32_t maxPacketCount = 5;
@@ -103,10 +115,21 @@
   apps.Start (Seconds (1.0));
   apps.Stop (Seconds (10.0));
 
-  AsciiTraceHelper ascii;
-  lrWpanHelper.EnableAsciiAll (ascii.CreateFileStream ("Ping-6LoW-lr-wpan.tr"));
-  lrWpanHelper.EnablePcapAll (std::string ("Ping-6LoW-lr-wpan"), true);
-  
+  if (!disableAsciiTrace)
+    {
+      AsciiTraceHelper ascii;
+      lrWpanHelper.EnableAsciiAll (ascii.CreateFileStream ("Ping-6LoW-lr-wpan.tr"));
+    }
+  if (!disablePcap)
+    {
+      lrWpanHelper.EnablePcapAll (std::string ("Ping-6LoW-lr-wpan"), true);
+    }
+  if (enableLSixlowLogLevelInfo)
+    {
+      Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> (&std::cout);
+      Ipv6RoutingHelper::PrintNeighborCacheAllAt (Seconds(9), routingStream);
+    }
+
   Simulator::Stop (Seconds (10));
   
   Simulator::Run ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc ns-3.31/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc
--- ns-3.30.1/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,141 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include <fstream>
+#include "ns3/core-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/mobility-module.h"
+#include "ns3/spectrum-module.h"
+#include "ns3/propagation-module.h"
+#include "ns3/sixlowpan-module.h"
+#include "ns3/lr-wpan-module.h"
+#include "ns3/csma-module.h"
+
+using namespace ns3;
+
+int main (int argc, char** argv)
+{
+  bool verbose = false;
+
+  Packet::EnablePrinting ();
+
+  CommandLine cmd (__FILE__);
+  cmd.AddValue ("verbose", "turn on log components", verbose);
+  cmd.Parse (argc, argv);
+
+  if (verbose)
+    {
+      LogComponentEnable ("Ping6Application", LOG_LEVEL_ALL);
+      LogComponentEnable ("LrWpanMac", LOG_LEVEL_ALL);
+      LogComponentEnable ("LrWpanPhy", LOG_LEVEL_ALL);
+      LogComponentEnable ("LrWpanNetDevice", LOG_LEVEL_ALL);
+      LogComponentEnable ("SixLowPanNetDevice", LOG_LEVEL_ALL);
+    }
+
+  uint32_t nWsnNodes = 4;
+  NodeContainer wsnNodes;
+  wsnNodes.Create (nWsnNodes);
+
+  NodeContainer wiredNodes;
+  wiredNodes.Create (1);
+  wiredNodes.Add (wsnNodes.Get (0));
+
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.SetPositionAllocator ("ns3::GridPositionAllocator",
+                                 "MinX", DoubleValue (0.0),
+                                 "MinY", DoubleValue (0.0),
+                                 "DeltaX", DoubleValue (80),
+                                 "DeltaY", DoubleValue (80),
+                                 "GridWidth", UintegerValue (10),
+                                 "LayoutType", StringValue ("RowFirst"));
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.Install (wsnNodes);
+
+  LrWpanHelper lrWpanHelper;
+  // Add and install the LrWpanNetDevice for each node
+  NetDeviceContainer lrwpanDevices = lrWpanHelper.Install (wsnNodes);
+
+  // Fake PAN association and short address assignment.
+  // This is needed because the lr-wpan module does not provide (yet)
+  // a full PAN association procedure.
+  lrWpanHelper.AssociateToPan (lrwpanDevices, 0);
+
+  InternetStackHelper internetv6;
+  internetv6.Install (wsnNodes);
+  internetv6.Install (wiredNodes.Get (0));
+
+  SixLowPanHelper sixLowPanHelper;
+  NetDeviceContainer sixLowPanDevices = sixLowPanHelper.Install (lrwpanDevices);
+
+  CsmaHelper csmaHelper;
+  NetDeviceContainer csmaDevices = csmaHelper.Install (wiredNodes);
+
+  Ipv6AddressHelper ipv6;
+  ipv6.SetBase (Ipv6Address ("2001:cafe::"), Ipv6Prefix (64));
+  Ipv6InterfaceContainer wiredDeviceInterfaces;
+  wiredDeviceInterfaces = ipv6.Assign (csmaDevices);
+  wiredDeviceInterfaces.SetForwarding (1, true);
+  wiredDeviceInterfaces.SetDefaultRouteInAllNodes (1);
+
+  ipv6.SetBase (Ipv6Address ("2001:f00d::"), Ipv6Prefix (64));
+  Ipv6InterfaceContainer wsnDeviceInterfaces;
+  wsnDeviceInterfaces = ipv6.Assign (sixLowPanDevices);
+  wsnDeviceInterfaces.SetForwarding (0, true);
+  wsnDeviceInterfaces.SetDefaultRouteInAllNodes (0);
+
+  for (uint32_t i = 0; i < sixLowPanDevices.GetN (); i++)
+    {
+      Ptr<NetDevice> dev = sixLowPanDevices.Get (i);
+      dev->SetAttribute ("UseMeshUnder", BooleanValue (true));
+      dev->SetAttribute ("MeshUnderRadius", UintegerValue (10));
+    }
+
+  uint32_t packetSize = 10;
+  uint32_t maxPacketCount = 5;
+  Time interPacketInterval = Seconds (1.);
+  Ping6Helper ping6;
+
+  ping6.SetLocal (wsnDeviceInterfaces.GetAddress (nWsnNodes - 1, 1));
+  ping6.SetRemote (wiredDeviceInterfaces.GetAddress (0, 1));
+
+  ping6.SetAttribute ("MaxPackets", UintegerValue (maxPacketCount));
+  ping6.SetAttribute ("Interval", TimeValue (interPacketInterval));
+  ping6.SetAttribute ("PacketSize", UintegerValue (packetSize));
+  ApplicationContainer apps = ping6.Install (wsnNodes.Get (nWsnNodes - 1));
+
+  apps.Start (Seconds (1.0));
+  apps.Stop (Seconds (10.0));
+
+  AsciiTraceHelper ascii;
+  lrWpanHelper.EnableAsciiAll (ascii.CreateFileStream ("Ping-6LoW-lr-wpan-meshunder-lr-wpan.tr"));
+  lrWpanHelper.EnablePcapAll (std::string ("Ping-6LoW-lr-wpan-meshunder-lr-wpan"), true);
+
+  csmaHelper.EnableAsciiAll (ascii.CreateFileStream ("Ping-6LoW-lr-wpan-meshunder-csma.tr"));
+  csmaHelper.EnablePcapAll (std::string ("Ping-6LoW-lr-wpan-meshunder-csma"), true);
+
+  Simulator::Stop (Seconds (10));
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+}
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/sixlowpan/examples/example-sixlowpan.cc ns-3.31/src/sixlowpan/examples/example-sixlowpan.cc
--- ns-3.30.1/src/sixlowpan/examples/example-sixlowpan.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/sixlowpan/examples/example-sixlowpan.cc	2020-06-27 17:38:30.000000000 -0700
@@ -43,9 +43,6 @@
 #include "ns3/internet-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-apps-module.h"
-#include "ns3/ipv6-static-routing-helper.h"
-
-#include "ns3/ipv6-routing-table-entry.h"
 #include "ns3/sixlowpan-module.h"
 
 using namespace ns3;
@@ -56,7 +53,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on some relevant log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/sixlowpan/examples/wscript ns-3.31/src/sixlowpan/examples/wscript
--- ns-3.30.1/src/sixlowpan/examples/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/sixlowpan/examples/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -11,3 +11,11 @@
     obj = bld.create_ns3_program('example-ping-lr-wpan',
                                  ['network', 'sixlowpan', 'internet', 'lr-wpan', 'internet-apps'])
     obj.source = 'example-ping-lr-wpan.cc'
+    
+    obj = bld.create_ns3_program('example-ping-lr-wpan-beacon',
+                                 ['network', 'sixlowpan', 'internet', 'lr-wpan', 'internet-apps'])
+    obj.source = 'example-ping-lr-wpan-beacon.cc'
+
+    obj = bld.create_ns3_program('example-ping-lr-wpan-mesh-under',
+                                 ['network', 'sixlowpan', 'internet', 'lr-wpan', 'internet-apps', 'csma'])
+    obj.source = 'example-ping-lr-wpan-mesh-under.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/sixlowpan/model/sixlowpan-header.cc ns-3.31/src/sixlowpan/model/sixlowpan-header.cc
--- ns-3.30.1/src/sixlowpan/model/sixlowpan-header.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/sixlowpan/model/sixlowpan-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -23,6 +23,9 @@
 #include "ns3/log.h"
 #include "ns3/abort.h"
 #include "ns3/ipv6-header.h"
+#include "ns3/mac64-address.h"
+#include "ns3/mac16-address.h"
+#include "ns3/ipv6-header.h"
 #include "sixlowpan-header.h"
 
 
@@ -128,7 +131,7 @@
   encoding <<= 1;
   encoding |= m_hc2HeaderPresent;
 
-  os << "encoding " << static_cast<int> (encoding) << ", hopLimit " << static_cast<int> (m_hopLimit);
+  os << "encoding " << +encoding << ", hopLimit " << +m_hopLimit;
 }
 
 uint32_t SixLowPanHc1::GetSerializedSize () const
@@ -545,7 +548,7 @@
 
 SixLowPanFrag1::SixLowPanFrag1 ()
   : m_datagramSize (0),
-    m_datagramTag (0)
+  m_datagramTag (0)
 {
 }
 
@@ -632,8 +635,8 @@
 
 SixLowPanFragN::SixLowPanFragN ()
   : m_datagramSize (0),
-    m_datagramTag (0),
-    m_datagramOffset (0)
+  m_datagramTag (0),
+  m_datagramOffset (0)
 {
 }
 /*
@@ -655,7 +658,7 @@
 
 void SixLowPanFragN::Print (std::ostream & os) const
 {
-  os << "datagram size " << m_datagramSize << " tag " << m_datagramTag << " offset " << static_cast<int> (m_datagramOffset);
+  os << "datagram size " << m_datagramSize << " tag " << m_datagramTag << " offset " << +m_datagramOffset;
 }
 
 uint32_t SixLowPanFragN::GetSerializedSize () const
@@ -815,7 +818,7 @@
 
 void SixLowPanIphc::Print (std::ostream & os) const
 {
-  os << "Compression kind: " << static_cast<int> (m_baseFormat);
+  os << "Compression kind: " << +m_baseFormat;
 }
 
 uint32_t SixLowPanIphc::GetSerializedSize () const
@@ -1508,7 +1511,7 @@
 
 void SixLowPanNhcExtension::Print (std::ostream & os) const
 {
-  os << "Compression kind: " << static_cast<int> (m_nhcExtensionHeader) << " Size: " << GetSerializedSize ();
+  os << "Compression kind: " << +m_nhcExtensionHeader << " Size: " << GetSerializedSize ();
 }
 
 uint32_t SixLowPanNhcExtension::GetSerializedSize () const
@@ -1637,7 +1640,7 @@
 
 void SixLowPanUdpNhcExtension::Print (std::ostream & os) const
 {
-  os << "Compression kind: " << static_cast<int> (m_baseFormat);
+  os << "Compression kind: " << +m_baseFormat;
 }
 
 uint32_t SixLowPanUdpNhcExtension::GetSerializedSize () const
@@ -1805,6 +1808,317 @@
   return os;
 }
 
+/*
+ * SixLowPanBc0
+ */
+NS_OBJECT_ENSURE_REGISTERED (SixLowPanBc0);
+
+SixLowPanBc0::SixLowPanBc0 ()
+{
+  m_seqNumber = 66;
+}
+
+TypeId SixLowPanBc0::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::SixLowPanBc0")
+    .SetParent<Header> ()
+    .SetGroupName ("SixLowPan")
+    .AddConstructor<SixLowPanBc0> ();
+  return tid;
+}
+
+TypeId SixLowPanBc0::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void SixLowPanBc0::Print (std::ostream & os) const
+{
+  os << "Sequence number: " << +m_seqNumber;
+}
+
+uint32_t SixLowPanBc0::GetSerializedSize () const
+{
+  return 2;
+}
+
+void SixLowPanBc0::Serialize (Buffer::Iterator start) const
+{
+  Buffer::Iterator i = start;
+  i.WriteU8 (0x50);
+  i.WriteU8 (m_seqNumber);
+
+}
+
+uint32_t SixLowPanBc0::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+  uint8_t dispatch = i.ReadU8 ();
+
+  if (dispatch != 0x50)
+    {
+      return 0;
+    }
+
+  m_seqNumber = i.ReadU8 ();
+
+  return GetSerializedSize ();
+}
+
+void SixLowPanBc0::SetSequenceNumber (uint8_t seqNumber)
+{
+  m_seqNumber = seqNumber;
+}
+
+uint8_t SixLowPanBc0::GetSequenceNumber (void) const
+{
+  return m_seqNumber;
+}
+
+std::ostream & operator << (std::ostream & os, const SixLowPanBc0 & h)
+{
+  h.Print (os);
+  return os;
+}
+
+/*
+ * SixLowPanMesh
+ */
+NS_OBJECT_ENSURE_REGISTERED (SixLowPanMesh);
+
+SixLowPanMesh::SixLowPanMesh ()
+{
+  m_hopsLeft = 0;
+  m_src = Address ();
+  m_dst = Address ();
+  m_v = false;
+  m_f = false;
+}
+
+TypeId SixLowPanMesh::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::SixLowPanMesh")
+    .SetParent<Header> ()
+    .SetGroupName ("SixLowPan")
+    .AddConstructor<SixLowPanMesh> ();
+  return tid;
+}
+
+TypeId SixLowPanMesh::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void SixLowPanMesh::Print (std::ostream & os) const
+{
+  os << "Hops left: " << +m_hopsLeft << ", src: ";
+  if (Mac64Address::IsMatchingType (m_src))
+    {
+      os << Mac64Address::ConvertFrom (m_src);
+    }
+  else
+    {
+      os << Mac16Address::ConvertFrom (m_src);
+    }
+  os << ", dst: ";
+  if (Mac64Address::IsMatchingType (m_dst))
+    {
+      os << Mac64Address::ConvertFrom (m_dst);
+    }
+  else
+    {
+      os << Mac16Address::ConvertFrom (m_dst);
+    }
+}
+
+uint32_t SixLowPanMesh::GetSerializedSize () const
+{
+  uint32_t serializedSize = 1;
+
+  if (m_hopsLeft >= 0xF)
+    {
+      serializedSize++;
+    }
+
+  if (m_v)
+    {
+      serializedSize += 2;
+    }
+  else
+    {
+      serializedSize += 8;
+    }
+
+  if (m_f)
+    {
+      serializedSize += 2;
+    }
+  else
+    {
+      serializedSize += 8;
+    }
+
+  return serializedSize;
+}
+
+void SixLowPanMesh::Serialize (Buffer::Iterator start) const
+{
+  Buffer::Iterator i = start;
+
+  uint8_t dispatch = 0x80;
+
+  if (m_v)
+    {
+      dispatch |= 0x20;
+    }
+  if (m_f)
+    {
+      dispatch |= 0x10;
+    }
+
+  if (m_hopsLeft < 0xF)
+    {
+      dispatch |= m_hopsLeft;
+      i.WriteU8 (dispatch);
+    }
+  else
+    {
+      dispatch |= 0xF;
+      i.WriteU8 (dispatch);
+      i.WriteU8 (m_hopsLeft);
+    }
+
+  uint8_t buffer[8];
+
+  m_src.CopyTo (buffer);
+  if (m_v)
+    {
+      i.Write (buffer, 2);
+    }
+  else
+    {
+      i.Write (buffer, 8);
+    }
+
+  m_dst.CopyTo (buffer);
+  if (m_f)
+    {
+      i.Write (buffer, 2);
+    }
+  else
+    {
+      i.Write (buffer, 8);
+    }
+}
+
+uint32_t SixLowPanMesh::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+  uint8_t temp = i.ReadU8 ();
+
+  if ((temp & 0xC0) != 0x80)
+    {
+      return 0;
+    }
+
+  m_v = temp & 0x20;
+  m_f = temp & 0x10;
+  m_hopsLeft = temp & 0xF;
+
+  if (m_hopsLeft == 0xF)
+    {
+      m_hopsLeft = i.ReadU8 ();
+    }
+
+  uint8_t buffer[8];
+  uint8_t addrSize;
+
+  if (m_v)
+    {
+      addrSize = 2;
+    }
+  else
+    {
+      addrSize = 8;
+    }
+  i.Read (buffer, addrSize);
+  m_src.CopyFrom (buffer, addrSize);
+
+  if (m_f)
+    {
+      addrSize = 2;
+    }
+  else
+    {
+      addrSize = 8;
+    }
+  i.Read (buffer, addrSize);
+  m_dst.CopyFrom (buffer, addrSize);
+
+  return GetSerializedSize ();
+}
+
+void SixLowPanMesh::SetOriginator (Address originator)
+{
+  if (Mac64Address::IsMatchingType (originator))
+    {
+      m_v = false;
+    }
+  else if (Mac16Address::IsMatchingType (originator))
+    {
+      m_v = true;
+    }
+  else
+    {
+      NS_ABORT_MSG ("SixLowPanMesh::SetOriginator - incompatible address");
+    }
+
+  m_src = originator;
+}
+
+Address SixLowPanMesh::GetOriginator (void) const
+{
+  return m_src;
+}
+
+void SixLowPanMesh::SetFinalDst (Address finalDst)
+{
+  if (Mac64Address::IsMatchingType (finalDst))
+    {
+      m_f = false;
+    }
+  else if (Mac16Address::IsMatchingType (finalDst))
+    {
+      m_f = true;
+    }
+  else
+    {
+      NS_ABORT_MSG ("SixLowPanMesh::SetFinalDst - incompatible address");
+    }
+
+  m_dst = finalDst;
+}
+
+Address SixLowPanMesh::GetFinalDst (void) const
+{
+  return m_dst;
+}
+
+void SixLowPanMesh::SetHopsLeft (uint8_t hopsLeft)
+{
+  m_hopsLeft = hopsLeft;
+}
+
+uint8_t SixLowPanMesh::GetHopsLeft (void) const
+{
+  return m_hopsLeft;
+}
+
+std::ostream & operator << (std::ostream & os, const SixLowPanMesh & h)
+{
+  h.Print (os);
+  return os;
+}
 
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/sixlowpan/model/sixlowpan-header.h ns-3.31/src/sixlowpan/model/sixlowpan-header.h
--- ns-3.30.1/src/sixlowpan/model/sixlowpan-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/sixlowpan/model/sixlowpan-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -1236,6 +1236,168 @@
  */
 std::ostream & operator<< (std::ostream & os, SixLowPanUdpNhcExtension const &header);
 
+/**
+ * \ingroup sixlowpan
+ * \brief 6LoWPAN BC0 header - see \RFC{4944}.
+ */
+class SixLowPanBc0 : public Header
+{
+public:
+  SixLowPanBc0 (void);
+
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * \brief Return the instance type identifier.
+   * \return Instance type ID.
+   */
+  virtual TypeId GetInstanceTypeId (void) const;
+
+  virtual void Print (std::ostream& os) const;
+
+  /**
+   * \brief Get the serialized size of the packet.
+   * \return Size.
+   */
+  virtual uint32_t GetSerializedSize (void) const;
+
+  /**
+   * \brief Serialize the packet.
+   * \param [in] start Buffer iterator.
+   */
+  virtual void Serialize (Buffer::Iterator start) const;
+
+  /**
+   * \brief Deserialize the packet.
+   * \param [in] start Buffer iterator.
+   * \return Size of the packet.
+   */
+  virtual uint32_t Deserialize (Buffer::Iterator start);
+
+  /**
+   * \brief Set the "Sequence Number" field.
+   * \param [in] seqNumber The sequence number value.
+   */
+  void SetSequenceNumber (uint8_t seqNumber);
+
+  /**
+   * \brief Get the "Sequence Number" field.
+   * \return The sequence number value.
+   */
+  uint8_t GetSequenceNumber (void) const;
+
+private:
+  uint8_t m_seqNumber;          //!< Sequence number.
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] header The BC0 Extension Header.
+ * \returns The reference to the output stream.
+ */
+std::ostream & operator<< (std::ostream & os, SixLowPanBc0 const &header);
+
+/**
+ * \ingroup sixlowpan
+ * \brief 6LoWPAN Mesh header - see \RFC{4944}.
+ */
+class SixLowPanMesh : public Header
+{
+public:
+  SixLowPanMesh (void);
+
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * \brief Return the instance type identifier.
+   * \return Instance type ID.
+   */
+  virtual TypeId GetInstanceTypeId (void) const;
+
+  virtual void Print (std::ostream& os) const;
+
+  /**
+   * \brief Get the serialized size of the packet.
+   * \return Size.
+   */
+  virtual uint32_t GetSerializedSize (void) const;
+
+  /**
+   * \brief Serialize the packet.
+   * \param [in] start Buffer iterator.
+   */
+  virtual void Serialize (Buffer::Iterator start) const;
+
+  /**
+   * \brief Deserialize the packet.
+   * \param [in] start Buffer iterator.
+   * \return Size of the packet.
+   */
+  virtual uint32_t Deserialize (Buffer::Iterator start);
+
+  /**
+   * \brief Set the "Hops Left" field.
+   * \param [in] hopsLeft The number of hops left.
+   */
+  void SetHopsLeft (uint8_t hopsLeft);
+
+  /**
+   * \brief Get the "Hops Left" field.
+   * \return The number of hops left.
+   */
+  uint8_t GetHopsLeft (void) const;
+
+  /**
+   * \brief Set the "Originator" address.
+   * \param [in] originator The Originator address (Mac64Address or Mac16Address).
+   */
+  void SetOriginator (Address originator);
+
+  /**
+   * \brief Get the "Originator" address.
+   * \return The Originator address (Mac64Address or Mac16Address).
+   */
+  Address GetOriginator (void) const;
+
+  /**
+   * \brief Set the "Final Destination" address.
+   * \param [in] finalDst The Final Destination address (Mac64Address or Mac16Address).
+   */
+  void SetFinalDst (Address finalDst);
+
+  /**
+   * \brief Get the "Final Destination" address.
+   * \return The Final Destination address (Mac64Address or Mac16Address).
+   */
+  Address GetFinalDst (void) const;
+
+private:
+  uint8_t m_hopsLeft; //!< Hops left.
+  bool m_v;           //!< True if Originator address is 16 bit
+  bool m_f;           //!< True if Destination address is 16 bit
+  Address m_src;      //!< Originator (source) address.
+  Address m_dst;      //!< Destination (final) address.
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] header The Mesh Extension Header.
+ * \returns The reference to the output stream.
+ */
+std::ostream & operator<< (std::ostream & os, SixLowPanMesh const &header);
+
 }
 
 #endif /* SIXLOWPANHEADER_H_ */
